# Aseba

Copyright (C) 2007–2017:
Stéphane Magnenat <stephane at magnenat dot net> (http://stephane.magnenat.net) and other contributors, see [authors.txt](authors.txt) for details.
Released under LGPL3, see [license.txt](license.txt) for details.
	
Aseba means **a**ctuator and **s**ensor **e**vent-**b**ased **a**rchitecture.
It is a set of tools which allow beginners to program robots easily and efficiently.
For more information, see: http://aseba.wikidot.com

## Supported platforms

The following platforms are supported:
- Linux ([compilation instructions](compile.Linux.md))
- macOS ([compilation instructions](compile.macOS.md))
- Windows ([compilation instructions](compile.Windows.md))
- embedded systems ([see the dependency list](compile.deps.md))

## Use Aseba

Informations on how to use Aseba is available on [http://aseba.wikidot.com](https://www.thymio.org/en:asebausermanual).

If you use Aseba in an academic project leading to a publication, please cite:

> ASEBA: A Modular Architecture for Event-Based Control of Complex Robots
> Stéphane Magnenat, Philippe Rétornaz, Michael Bonani, Valentin Longchamp, and Francesco Mondada.
> In IEEE/ASME Transactions on Mechatronics, 16(2), pages 321–329, April, 2011, DOI: 10.1109/TMECH.2010.2042722.
    
[full text document](https://infoscience.epfl.ch/record/144059/files/aseba-ieee-tr.pdf)

## Hack and contribute

If you found a bug with Aseba, please look at the [existing issues](https://github.com/aseba-community/aseba/issues) to see if your problem has already been reported.
If not, please [open a new issue](https://github.com/aseba-community/aseba/issues/new).

If you want to help us translating Aseba or its documentation, please read the [localization guide](localization.md).

If you are interested in contributing to programming Aseba, please read the [contributor guide](contributing.md).

Enjoy Aseba!

The developers
